Bug 73317 - desktop entry spec: Add support for Implements=
Summary: desktop entry spec: Add support for Implements=
Status: RESOLVED FIXED
Alias: None
Product: Specifications
Classification: Unclassified
Component: desktop-entry (show other bugs)
Version: unspecified
Hardware: Other All
: medium normal
Assignee: Vincent Untz
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2014-01-06 05:31 UTC by Allison Lortie (desrt)
Modified: 2014-04-10 16:21 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments
desktop entry spec: Add support for Implements= (3.84 KB, patch)
2014-01-06 05:31 UTC, Allison Lortie (desrt)
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Allison Lortie (desrt) 2014-01-06 05:31:59 UTC
Created attachment 91532 [details] [review]
desktop entry spec: Add support for Implements=

See attached patch.
Comment 1 Vincent Untz 2014-01-06 07:37:13 UTC
Comment on attachment 91532 [details] [review]
desktop entry spec: Add support for Implements=

Review of attachment 91532 [details] [review]:
-----------------------------------------------------------------

::: desktop-entry/desktop-entry-spec.xml
@@ +896,5 @@
> +      The <varname>Implements</varname> key can be used to declare one or more interfaces that a desktop file
> +      implements.
> +    </para>
> +    <para>
> +      Each interface name must follow the rules used for D-Bus interface names, but other than they, they have

Typo in "other than they"

@@ +902,5 @@
> +      application implements that D-Bus interface or even that such a D-Bus interface exists.  It is entirely up
> +      to the entity who defined a particular interface to define what it means to implement it.
> +    </para>
> +    <para>
> +      Although it is entirely up to you to decide what a given interface name means, here are some recommended

In general, we don't use "you" in the spec, iirc. It's actually unclear who this would be: people writing desktop files or people reading desktop files?
Comment 2 David Faure 2014-01-06 08:38:03 UTC
Comment on attachment 91532 [details] [review]
desktop entry spec: Add support for Implements=

This is missing something very important: where are listed the available interfaces that can be used here?

Maybe just a link to some freedesktop wiki page with zero or one interface as a starting point, but this is definitely needed, for anyone reading this spec to be able to find out the available interfaces or where to add the one they want to define so others can know about it.
Comment 3 Jerome Leclanche 2014-01-10 06:31:27 UTC
(In reply to comment #2)
> Comment on attachment 91532 [details] [review] [review]
> desktop entry spec: Add support for Implements=
> 
> This is missing something very important: where are listed the available
> interfaces that can be used here?

I've been talking to Alex Fiestas to implement an org.kde.intents.Camera.TakePicture interface of his choosing in kamoso, as a starting point (I'd love to demo that at fosdem though we're tight on time for that).

PCMan mentioned this is all a very solid alternative to the current various hacky ways we have of displaying file picker dialogs: A "file picker" app can be installed (eg as part of the file manager or on its own) and support org.freedesktop.intents.FileManager.FilePickerDialog or something similar. This would allow for a shared, integrated file picker between DEs.
Comment 4 Jerome Leclanche 2014-02-04 18:17:39 UTC
After meeting up with Ryan at FOSDEM we discussed the potential use cases.

Ryan wants a more generic "Implements", which would be able to contain any dbus-like addresses for anything the app implements.

Intents, as a concept, would reuse the Implements key (as the app would implement the intents).

So it could look something like this:

Name=MediaUploader
Implements=org.freedesktop.intents.ShareFile

[Intent org.freedesktop.intents.ShareFile]
MimeType=image/png;
Comment 5 Jerome Leclanche 2014-02-04 18:18:50 UTC
(In reply to comment #4)
> After meeting up with Ryan at FOSDEM we discussed the potential use cases.
> 
> Ryan wants a more generic "Implements", which would be able to contain any
> dbus-like addresses for anything the app implements.
> 
> Intents, as a concept, would reuse the Implements key (as the app would
> implement the intents).
> 
> So it could look something like this:
> 
> Name=MediaUploader
> Implements=org.freedesktop.intents.ShareFile
> 
> [Intent org.freedesktop.intents.ShareFile]
> MimeType=image/png;

Note that this also implies we don't need intents examples (like android has) for this particular bug.

I'm OK with this; David?
Comment 6 Allison Lortie (desrt) 2014-04-10 16:21:43 UTC
Pushed.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.